diff -urN qmail-1.03-vanilla/FILES qmail-1.03-md24/FILES
--- qmail-1.03-vanilla/FILES	1998-06-15 12:53:16.000000000 +0200
+++ qmail-1.03-md24/FILES	2007-07-19 23:13:50.000000000 +0200
@@ -1,9 +1,12 @@
+BIN.Makefile
+BIN.README
 BLURB
 BLURB2
 BLURB3
 BLURB4
-README
+CHANGES
 FAQ
+FILES
 INSTALL
 INSTALL.alias
 INSTALL.ctl
@@ -11,18 +14,8 @@
 INSTALL.maildir
 INSTALL.mbox
 INSTALL.vsm
-REMOVE.sendmail
-REMOVE.binmail
-TEST.deliver
-TEST.receive
-UPGRADE
-THOUGHTS
-TODO
-THANKS
-CHANGES
-SECURITY
 INTERNALS
-SENDMAIL
+Makefile
 PIC.local2alias
 PIC.local2ext
 PIC.local2local
@@ -32,402 +25,444 @@
 PIC.relaybad
 PIC.relaygood
 PIC.rem2local
-FILES
-VERSION
+README
+REMOVE.binmail
+REMOVE.sendmail
+SECURITY
+SENDMAIL
 SYSDEPS
 TARGETS
-Makefile
-BIN.README
-BIN.Makefile
-idedit.c
-conf-break
+TEST.deliver
+TEST.receive
+THANKS
+THOUGHTS
+TODO
+UPGRADE
+VERSION
+addresses.5
+alloc.3
+alloc.c
+alloc.h
+alloc_re.c
+auto-gid.c
+auto-int.c
+auto-int8.c
+auto-str.c
+auto-uid.c
 auto_break.h
-conf-spawn
+auto_patrn.h
+auto_qmail.h
 auto_spawn.h
-chkspawn.c
-conf-split
 auto_split.h
-conf-patrn
-auto_patrn.h
-conf-users
-conf-groups
 auto_uids.h
 auto_usera.h
-extra.h
-addresses.5
-except.1
+base64.c
+base64.h
+binm1+df.sh
+binm1.sh
+binm2+df.sh
+binm2.sh
+binm3+df.sh
+binm3.sh
 bouncesaying.1
+bouncesaying.c
+byte.h
+byte_chr.c
+byte_copy.c
+byte_cr.c
+byte_cspn.c
+byte_diff.c
+byte_rchr.c
+byte_rcspn.c
+byte_zero.c
+case.3
+case.h
+case_diffb.c
+case_diffs.c
+case_lowerb.c
+case_lowers.c
+case_starts.c
+cdb.3
+cdb.h
+cdb_hash.c
+cdb_seek.c
+cdb_unpack.c
+cdbmake.h
+cdbmake_add.c
+cdbmake_hash.c
+cdbmake_pack.c
+cdbmss.c
+cdbmss.h
+chkshsgr.c
+chkspawn.c
+coe.3
+coe.c
+coe.h
+commands.c
+commands.h
 condredirect.1
+condredirect.c
+conf-break
+conf-cc
+conf-groups
+conf-ld
+conf-patrn
+conf-qmail
+conf-spawn
+conf-split
+conf-users
+config-fast.sh
+config.sh
+constmap.c
+constmap.h
+control.c
+control.h
+date822fmt.c
+date822fmt.h
+datemail.sh
+datetime.3
+datetime.c
+datetime.h
+datetime_un.c
+direntry.3
+direntry.h1
+direntry.h2
+dns.c
+dns.h
+dnscname.c
+dnsdoe.c
+dnsdoe.h
+dnsfq.c
+dnsip.c
+dnsmxip.c
+dnsptr.c
+dnstxt.c
 dot-qmail.9
+elq.sh
+env.3
+env.c
+env.h
 envelopes.5
+envread.c
+error.3
+error.c
+error.h
+error_str.3
+error_str.c
+error_temp.3
+error_temp.c
+except.1
+except.c
+exit.h
+extra.h
+fd.h
+fd_copy.3
+fd_copy.c
+fd_move.3
+fd_move.c
+fifo.c
+fifo.h
+fifo_make.3
+find-systype.sh
+fmt.h
+fmt_str.c
+fmt_strn.c
+fmt_uint.c
+fmt_uint0.c
+fmt_ulong.c
+fmtqfn.c
+fmtqfn.h
 forgeries.7
+fork.h1
+fork.h2
 forward.1
+forward.c
+gen_alloc.h
+gen_allocdefs.h
+getln.3
+getln.c
+getln.h
+getln2.3
+getln2.c
+gfrom.c
+gfrom.h
+headerbody.c
+headerbody.h
+hfield.c
+hfield.h
+hier.c
+hmac.h
+hmac_md5.c
+hmac_md5.o
+hmac_ripemd.c
+hmac_ripemd.o
+hmac_sha1.c
+hmac_sha1.h
+home+df.sh
+home.sh
+hostname.c
+idedit.c
+install-big.c
+install.c
+install.h
+instcheck.c
+ip.c
+ip.h
+ipalloc.c
+ipalloc.h
+ipme.c
+ipme.h
+ipmeprint.c
+lock.h
+lock_ex.c
+lock_exnb.c
+lock_un.c
+maildir.5
+maildir.c
+maildir.h
 maildir2mbox.1
+maildir2mbox.c
 maildirmake.1
+maildirmake.c
 maildirwatch.1
+maildirwatch.c
 mailsubj.1
+mailsubj.sh
+make-compile.sh
+make-load.sh
+make-makelib.sh
 mbox.5
+md5.c
+md5.h
+md5.o
+myctime.c
+myctime.h
+ndelay.c
+ndelay.h
+ndelay_off.c
+newfield.c
+newfield.h
+now.3
+now.c
+now.h
+open.h
+open_append.c
+open_excl.c
+open_read.c
+open_trunc.c
+open_write.c
+out_log.c
+out_log.h
+pinq.sh
+predate.c
 preline.1
+preline.c
+prioq.c
+prioq.h
+proc+df.sh
+proc.sh
+prot.c
+prot.h
+qail.sh
 qbiff.1
+qbiff.c
+qlx.h
 qmail-clean.8
+qmail-clean.c
 qmail-command.8
 qmail-control.9
 qmail-getpw.9
+qmail-getpw.c
 qmail-header.5
 qmail-inject.8
+qmail-inject.c
 qmail-limits.9
 qmail-local.8
+qmail-local.c
 qmail-log.5
 qmail-lspawn.8
+qmail-lspawn.c
 qmail-newmrh.9
+qmail-newmrh.c
 qmail-newu.9
+qmail-newu.c
+qmail-p0f.c
+qmail-p0f.h
+qmail-p0f.o
 qmail-pop3d.8
+qmail-pop3d.c
 qmail-popup.8
+qmail-popup.c
 qmail-pw2u.9
+qmail-pw2u.c
 qmail-qmqpc.8
+qmail-qmqpc.c
 qmail-qmqpd.8
+qmail-qmqpd.c
 qmail-qmtpd.8
+qmail-qmtpd.c
 qmail-qread.8
+qmail-qread.c
 qmail-qstat.8
+qmail-qstat.sh
 qmail-queue.8
+qmail-queue.c
 qmail-remote.8
+qmail-remote.c
 qmail-rspawn.8
+qmail-rspawn.c
+qmail-sasl.c
+qmail-sasl.h
 qmail-send.9
+qmail-send.c
 qmail-showctl.8
+qmail-showctl.c
 qmail-smtpd.8
+qmail-smtpd.c
 qmail-start.9
+qmail-start.c
 qmail-tcpok.8
+qmail-tcpok.c
 qmail-tcpto.8
+qmail-tcpto.c
+qmail-upq.sh
 qmail-users.9
 qmail.7
+qmail.c
+qmail.h
 qreceipt.1
-splogger.8
-tcp-env.1
-config.sh
-config-fast.sh
-qmail-clean.c
-qmail-getpw.c
-qmail-inject.c
-qmail-local.c
-qmail-lspawn.c
-qmail-newmrh.c
-qmail-newu.c
-qmail-pop3d.c
-qmail-popup.c
-qmail-pw2u.c
-qmail-qmqpc.c
-qmail-qmqpd.c
-qmail-qmtpd.c
-qmail-qread.c
-qmail-qstat.sh
-qmail-queue.c
-qmail-remote.c
-qmail-rspawn.c
-qmail-send.c
-qmail-showctl.c
-qmail-smtpd.c
-qmail-start.c
-qmail-tcpok.c
-qmail-tcpto.c
-spawn.c
-dnscname.c
-dnsfq.c
-dnsip.c
-dnsmxip.c
-dnsptr.c
-hostname.c
-ipmeprint.c
-tcp-env.c
-sendmail.c
 qreceipt.c
 qsmhook.c
-qbiff.c
-forward.c
-preline.c
-predate.c
-except.c
-bouncesaying.c
-condredirect.c
-maildirmake.c
-maildir2mbox.c
-maildirwatch.c
-splogger.c
-qail.sh
-elq.sh
-pinq.sh
-qmail-upq.sh
-datemail.sh
-mailsubj.sh
-qlx.h
-rcpthosts.h
-rcpthosts.c
-commands.h
-commands.c
-dnsdoe.h
-dnsdoe.c
-fmtqfn.h
-fmtqfn.c
-gfrom.h
-gfrom.c
-myctime.h
-myctime.c
-newfield.h
-newfield.c
-qsutil.h
 qsutil.c
-readsubdir.h
+qsutil.h
+quote.c
+quote.h
+rcpthosts.c
+rcpthosts.h
 readsubdir.c
-received.h
+readsubdir.h
+readwrite.h
+realrcptto.c
+realrcptto.o
 received.c
-tcpto.h
-tcpto.c
-tcpto_clean.c
-trigger.h
-trigger.c
-triggerpull.h
-triggerpull.c
-trynpbg1.c
-trysyslog.c
-conf-cc
-conf-ld
-home.sh
-home+df.sh
-proc.sh
-proc+df.sh
-binm1.sh
-binm2.sh
-binm3.sh
-binm1+df.sh
-binm2+df.sh
-binm3+df.sh
-find-systype.sh
-make-compile.sh
-make-load.sh
-make-makelib.sh
-trycpp.c
-warn-auto.sh
-auto-str.c
-auto-int.c
-auto-int8.c
-auto-gid.c
-auto-uid.c
-hier.c
-install.c
-instcheck.c
-install-big.c
-alloc.3
-alloc.h
-alloc.c
-alloc_re.c
-case.3
-case.h
-case_diffb.c
-case_diffs.c
-case_lowerb.c
-case_lowers.c
-case_starts.c
-cdb.3
-cdb.h
-cdb_hash.c
-cdb_seek.c
-cdb_unpack.c
-cdbmake.h
-cdbmake_add.c
-cdbmake_hash.c
-cdbmake_pack.c
-cdbmss.h
-cdbmss.c
-coe.3
-coe.h
-coe.c
-fd.h
-fd_copy.3
-fd_copy.c
-fd_move.3
-fd_move.c
-fifo_make.3
-fifo.h
-fifo.c
-trymkffo.c
-fork.h1
-fork.h2
-tryvfork.c
-now.3
-now.h
-now.c
-open.h
-open_append.c
-open_excl.c
-open_read.c
-open_trunc.c
-open_write.c
+received.h
+remoteinfo.c
+remoteinfo.h
+ripemd.c
+ripemd.h
+ripemd.o
+scan.h
+scan_8long.c
+scan_ulong.c
 seek.h
 seek_cur.c
 seek_end.c
 seek_set.c
 seek_trunc.c
-conf-qmail
-auto_qmail.h
-qmail.h
-qmail.c
-gen_alloc.h
-gen_allocdefs.h
-stralloc.3
-stralloc.h
-stralloc_eady.c
-stralloc_pend.c
-stralloc_copy.c
-stralloc_opyb.c
-stralloc_opys.c
-stralloc_cat.c
-stralloc_catb.c
-stralloc_cats.c
-stralloc_arts.c
-strerr.h
-strerr_sys.c
-strerr_die.c
-substdio.h
-substdio.c
-substdi.c
-substdo.c
-substdio_copy.c
-subfd.h
-subfderr.c
-subfdouts.c
-subfdout.c
-subfdins.c
-subfdin.c
-readwrite.h
-exit.h
-timeoutconn.h
-timeoutconn.c
-timeoutread.h
-timeoutread.c
-timeoutwrite.h
-timeoutwrite.c
-remoteinfo.h
-remoteinfo.c
-uint32.h1
-uint32.h2
-tryulong32.c
-wait.3
-wait.h
-wait_pid.c
-wait_nohang.c
-trywaitp.c
+select.h1
+select.h2
+sendmail.c
+sgetopt.3
+sgetopt.c
+sgetopt.h
+sha1.c
+sha1.h
+sha1.o
 sig.h
 sig_alarm.c
 sig_block.c
+sig_bug.c
 sig_catch.c
-sig_pause.c
-sig_pipe.c
 sig_child.c
-sig_term.c
 sig_hup.c
 sig_misc.c
-sig_bug.c
-trysgact.c
-trysgprm.c
-env.3
-env.h
-env.c
-envread.c
-byte.h
-byte_chr.c
-byte_copy.c
-byte_cr.c
-byte_diff.c
-byte_rchr.c
-byte_zero.c
+sig_pause.c
+sig_pipe.c
+sig_term.c
+slurpclose.c
+slurpclose.h
+spawn.c
+splogger.8
+splogger.c
 str.h
 str_chr.c
 str_cpy.c
+str_cpyb.c
 str_diff.c
 str_diffn.c
 str_len.c
 str_rchr.c
 str_start.c
-lock.h
-lock_ex.c
-lock_exnb.c
-lock_un.c
-tryflock.c
-getln.3
-getln.h
-getln.c
-getln2.3
-getln2.c
-sgetopt.3
-sgetopt.h
-sgetopt.c
+stralloc.3
+stralloc.h
+stralloc_arts.c
+stralloc_cat.c
+stralloc_catb.c
+stralloc_cats.c
+stralloc_copy.c
+stralloc_eady.c
+stralloc_opyb.c
+stralloc_opys.c
+stralloc_pend.c
+strerr.h
+strerr_die.c
+strerr_sys.c
+strsalloc.c
+strsalloc.h
+subfd.h
+subfderr.c
+subfdin.c
+subfdins.c
+subfdout.c
+subfdouts.c
 subgetopt.3
-subgetopt.h
 subgetopt.c
-error.3
-error_str.3
-error_temp.3
-error.h
-error.c
-error_str.c
-error_temp.c
-fmt.h
-fmt_str.c
-fmt_strn.c
-fmt_uint.c
-fmt_uint0.c
-fmt_ulong.c
-scan.h
-scan_ulong.c
-scan_8long.c
-slurpclose.h
-slurpclose.c
-quote.h
-quote.c
-hfield.h
-hfield.c
-headerbody.h
-headerbody.c
-token822.h
+subgetopt.h
+substdi.c
+substdio.c
+substdio.h
+substdio_copy.c
+substdo.c
+tcp-env.1
+tcp-env.c
+tcp-environ.5
+tcpto.c
+tcpto.h
+tcpto_clean.c
+timeoutconn.c
+timeoutconn.h
+timeoutread.c
+timeoutread.h
+timeoutwrite.c
+timeoutwrite.h
 token822.c
-control.h
-control.c
-datetime.3
-datetime.h
-datetime.c
-datetime_un.c
-prioq.h
-prioq.c
-date822fmt.h
-date822fmt.c
-dns.h
-dns.c
+token822.h
+trigger.c
+trigger.h
+triggerpull.c
+triggerpull.h
+trycpp.c
+trydrent.c
+tryflock.c
 trylsock.c
+trymkffo.c
+trynpbg1.c
 tryrsolv.c
-ip.h
-ip.c
-ipalloc.h
-ipalloc.c
-select.h1
-select.h2
+trysalen.c
+trysgact.c
+trysgprm.c
+tryshsgr.c
 trysysel.c
-ndelay.h
-ndelay.c
-ndelay_off.c
-direntry.3
-direntry.h1
-direntry.h2
-trydrent.c
-prot.h
-prot.c
-chkshsgr.c
+trysyslog.c
+tryulong32.c
+tryvfork.c
+trywaitp.c
+typesx.h
+uint32.h1
+uint32.h2
+wait.3
+wait.h
+wait_nohang.c
+wait_pid.c
+warn-auto.sh
 warn-shsgr
-tryshsgr.c
-ipme.h
-ipme.c
-trysalen.c
-maildir.5
-maildir.h
-maildir.c
-tcp-environ.5
-constmap.h
-constmap.c
diff -urN qmail-1.03-vanilla/fmt_str.c qmail-1.03-md24/fmt_str.c
--- qmail-1.03-vanilla/fmt_str.c	1998-06-15 12:53:16.000000000 +0200
+++ qmail-1.03-md24/fmt_str.c	2007-07-19 20:56:22.000000000 +0200
@@ -6,7 +6,7 @@
   register unsigned int len;
   char ch;
   len = 0;
-  if (s) { while (ch = t[len]) s[len++] = ch; }
+  if (s) { while ((ch = t[len])) s[len++] = ch; }
   else while (t[len]) len++;
   return len;
 }
diff -urN qmail-1.03-vanilla/forward.c qmail-1.03-md24/forward.c
--- qmail-1.03-vanilla/forward.c	1998-06-15 12:53:16.000000000 +0200
+++ qmail-1.03-md24/forward.c	2007-07-19 20:56:22.000000000 +0200
@@ -26,7 +26,7 @@
 
 char num[FMT_ULONG];
 
-void main(argc,argv)
+int main(argc,argv)
 int argc;
 char **argv;
 {
@@ -57,4 +57,5 @@
   qqx = qmail_close(&qqt);
   if (*qqx) strerr_die2x(*qqx == 'D' ? 100 : 111,FATAL,qqx + 1);
   strerr_die2x(0,"forward: qp ",num);
+  return 0;
 }
diff -urN qmail-1.03-vanilla/hfield.c qmail-1.03-md24/hfield.c
--- qmail-1.03-vanilla/hfield.c	1998-06-15 12:53:16.000000000 +0200
+++ qmail-1.03-md24/hfield.c	2007-07-19 20:56:22.000000000 +0200
@@ -41,7 +41,7 @@
  int i;
  char ch;
 
- for (i = 0;ch = t[i];++i)
+ for (i = 0;(ch = t[i]);++i)
   {
    if (i >= len) return 0;
    if (ch != s[i])
@@ -67,7 +67,7 @@
  int i;
  char *t;
 
- for (i = 1;t = hname[i];++i)
+ for (i = 1;(t = hname[i]);++i)
    if (hmatch(s,len,t))
      return i;
  return 0;
diff -urN qmail-1.03-vanilla/hier.c qmail-1.03-md24/hier.c
--- qmail-1.03-vanilla/hier.c	1998-06-15 12:53:16.000000000 +0200
+++ qmail-1.03-md24/hier.c	2007-07-19 20:56:22.000000000 +0200
@@ -1,3 +1,4 @@
+#include "install.h"
 #include "auto_qmail.h"
 #include "auto_split.h"
 #include "auto_uids.h"
@@ -55,6 +56,8 @@
   d(auto_qmail,"queue/bounce",auto_uids,auto_gidq,0700);
 
   dsplit("queue/mess",auto_uidq,0750);
+  dsplit("queue/todo",auto_uidq,0750);
+  dsplit("queue/intd",auto_uidq,0700);
   dsplit("queue/info",auto_uids,0700);
   dsplit("queue/local",auto_uids,0700);
   dsplit("queue/remote",auto_uids,0700);
@@ -145,108 +148,57 @@
   c(auto_qmail,"bin","pinq",auto_uido,auto_gidq,0755);
 
   c(auto_qmail,"man/man5","addresses.5",auto_uido,auto_gidq,0644);
-  c(auto_qmail,"man/cat5","addresses.0",auto_uido,auto_gidq,0644);
   c(auto_qmail,"man/man5","envelopes.5",auto_uido,auto_gidq,0644);
-  c(auto_qmail,"man/cat5","envelopes.0",auto_uido,auto_gidq,0644);
   c(auto_qmail,"man/man5","maildir.5",auto_uido,auto_gidq,0644);
-  c(auto_qmail,"man/cat5","maildir.0",auto_uido,auto_gidq,0644);
   c(auto_qmail,"man/man5","mbox.5",auto_uido,auto_gidq,0644);
-  c(auto_qmail,"man/cat5","mbox.0",auto_uido,auto_gidq,0644);
   c(auto_qmail,"man/man5","dot-qmail.5",auto_uido,auto_gidq,0644);
-  c(auto_qmail,"man/cat5","dot-qmail.0",auto_uido,auto_gidq,0644);
   c(auto_qmail,"man/man5","qmail-control.5",auto_uido,auto_gidq,0644);
-  c(auto_qmail,"man/cat5","qmail-control.0",auto_uido,auto_gidq,0644);
   c(auto_qmail,"man/man5","qmail-header.5",auto_uido,auto_gidq,0644);
-  c(auto_qmail,"man/cat5","qmail-header.0",auto_uido,auto_gidq,0644);
   c(auto_qmail,"man/man5","qmail-log.5",auto_uido,auto_gidq,0644);
-  c(auto_qmail,"man/cat5","qmail-log.0",auto_uido,auto_gidq,0644);
   c(auto_qmail,"man/man5","qmail-users.5",auto_uido,auto_gidq,0644);
-  c(auto_qmail,"man/cat5","qmail-users.0",auto_uido,auto_gidq,0644);
   c(auto_qmail,"man/man5","tcp-environ.5",auto_uido,auto_gidq,0644);
-  c(auto_qmail,"man/cat5","tcp-environ.0",auto_uido,auto_gidq,0644);
 
   c(auto_qmail,"man/man7","forgeries.7",auto_uido,auto_gidq,0644);
-  c(auto_qmail,"man/cat7","forgeries.0",auto_uido,auto_gidq,0644);
   c(auto_qmail,"man/man7","qmail-limits.7",auto_uido,auto_gidq,0644);
-  c(auto_qmail,"man/cat7","qmail-limits.0",auto_uido,auto_gidq,0644);
   c(auto_qmail,"man/man7","qmail.7",auto_uido,auto_gidq,0644);
-  c(auto_qmail,"man/cat7","qmail.0",auto_uido,auto_gidq,0644);
 
   c(auto_qmail,"man/man1","forward.1",auto_uido,auto_gidq,0644);
-  c(auto_qmail,"man/cat1","forward.0",auto_uido,auto_gidq,0644);
   c(auto_qmail,"man/man1","condredirect.1",auto_uido,auto_gidq,0644);
-  c(auto_qmail,"man/cat1","condredirect.0",auto_uido,auto_gidq,0644);
   c(auto_qmail,"man/man1","bouncesaying.1",auto_uido,auto_gidq,0644);
-  c(auto_qmail,"man/cat1","bouncesaying.0",auto_uido,auto_gidq,0644);
   c(auto_qmail,"man/man1","except.1",auto_uido,auto_gidq,0644);
-  c(auto_qmail,"man/cat1","except.0",auto_uido,auto_gidq,0644);
   c(auto_qmail,"man/man1","maildirmake.1",auto_uido,auto_gidq,0644);
-  c(auto_qmail,"man/cat1","maildirmake.0",auto_uido,auto_gidq,0644);
   c(auto_qmail,"man/man1","maildir2mbox.1",auto_uido,auto_gidq,0644);
-  c(auto_qmail,"man/cat1","maildir2mbox.0",auto_uido,auto_gidq,0644);
   c(auto_qmail,"man/man1","maildirwatch.1",auto_uido,auto_gidq,0644);
-  c(auto_qmail,"man/cat1","maildirwatch.0",auto_uido,auto_gidq,0644);
   c(auto_qmail,"man/man1","mailsubj.1",auto_uido,auto_gidq,0644);
-  c(auto_qmail,"man/cat1","mailsubj.0",auto_uido,auto_gidq,0644);
   c(auto_qmail,"man/man1","qreceipt.1",auto_uido,auto_gidq,0644);
-  c(auto_qmail,"man/cat1","qreceipt.0",auto_uido,auto_gidq,0644);
   c(auto_qmail,"man/man1","qbiff.1",auto_uido,auto_gidq,0644);
-  c(auto_qmail,"man/cat1","qbiff.0",auto_uido,auto_gidq,0644);
   c(auto_qmail,"man/man1","preline.1",auto_uido,auto_gidq,0644);
-  c(auto_qmail,"man/cat1","preline.0",auto_uido,auto_gidq,0644);
   c(auto_qmail,"man/man1","tcp-env.1",auto_uido,auto_gidq,0644);
-  c(auto_qmail,"man/cat1","tcp-env.0",auto_uido,auto_gidq,0644);
 
   c(auto_qmail,"man/man8","qmail-local.8",auto_uido,auto_gidq,0644);
-  c(auto_qmail,"man/cat8","qmail-local.0",auto_uido,auto_gidq,0644);
   c(auto_qmail,"man/man8","qmail-lspawn.8",auto_uido,auto_gidq,0644);
-  c(auto_qmail,"man/cat8","qmail-lspawn.0",auto_uido,auto_gidq,0644);
   c(auto_qmail,"man/man8","qmail-getpw.8",auto_uido,auto_gidq,0644);
-  c(auto_qmail,"man/cat8","qmail-getpw.0",auto_uido,auto_gidq,0644);
   c(auto_qmail,"man/man8","qmail-remote.8",auto_uido,auto_gidq,0644);
-  c(auto_qmail,"man/cat8","qmail-remote.0",auto_uido,auto_gidq,0644);
   c(auto_qmail,"man/man8","qmail-rspawn.8",auto_uido,auto_gidq,0644);
-  c(auto_qmail,"man/cat8","qmail-rspawn.0",auto_uido,auto_gidq,0644);
   c(auto_qmail,"man/man8","qmail-clean.8",auto_uido,auto_gidq,0644);
-  c(auto_qmail,"man/cat8","qmail-clean.0",auto_uido,auto_gidq,0644);
   c(auto_qmail,"man/man8","qmail-send.8",auto_uido,auto_gidq,0644);
-  c(auto_qmail,"man/cat8","qmail-send.0",auto_uido,auto_gidq,0644);
   c(auto_qmail,"man/man8","qmail-start.8",auto_uido,auto_gidq,0644);
-  c(auto_qmail,"man/cat8","qmail-start.0",auto_uido,auto_gidq,0644);
   c(auto_qmail,"man/man8","splogger.8",auto_uido,auto_gidq,0644);
-  c(auto_qmail,"man/cat8","splogger.0",auto_uido,auto_gidq,0644);
   c(auto_qmail,"man/man8","qmail-queue.8",auto_uido,auto_gidq,0644);
-  c(auto_qmail,"man/cat8","qmail-queue.0",auto_uido,auto_gidq,0644);
   c(auto_qmail,"man/man8","qmail-inject.8",auto_uido,auto_gidq,0644);
-  c(auto_qmail,"man/cat8","qmail-inject.0",auto_uido,auto_gidq,0644);
   c(auto_qmail,"man/man8","qmail-showctl.8",auto_uido,auto_gidq,0644);
-  c(auto_qmail,"man/cat8","qmail-showctl.0",auto_uido,auto_gidq,0644);
   c(auto_qmail,"man/man8","qmail-newmrh.8",auto_uido,auto_gidq,0644);
-  c(auto_qmail,"man/cat8","qmail-newmrh.0",auto_uido,auto_gidq,0644);
   c(auto_qmail,"man/man8","qmail-newu.8",auto_uido,auto_gidq,0644);
-  c(auto_qmail,"man/cat8","qmail-newu.0",auto_uido,auto_gidq,0644);
   c(auto_qmail,"man/man8","qmail-pw2u.8",auto_uido,auto_gidq,0644);
-  c(auto_qmail,"man/cat8","qmail-pw2u.0",auto_uido,auto_gidq,0644);
   c(auto_qmail,"man/man8","qmail-qread.8",auto_uido,auto_gidq,0644);
-  c(auto_qmail,"man/cat8","qmail-qread.0",auto_uido,auto_gidq,0644);
   c(auto_qmail,"man/man8","qmail-qstat.8",auto_uido,auto_gidq,0644);
-  c(auto_qmail,"man/cat8","qmail-qstat.0",auto_uido,auto_gidq,0644);
   c(auto_qmail,"man/man8","qmail-tcpok.8",auto_uido,auto_gidq,0644);
-  c(auto_qmail,"man/cat8","qmail-tcpok.0",auto_uido,auto_gidq,0644);
   c(auto_qmail,"man/man8","qmail-tcpto.8",auto_uido,auto_gidq,0644);
-  c(auto_qmail,"man/cat8","qmail-tcpto.0",auto_uido,auto_gidq,0644);
   c(auto_qmail,"man/man8","qmail-pop3d.8",auto_uido,auto_gidq,0644);
-  c(auto_qmail,"man/cat8","qmail-pop3d.0",auto_uido,auto_gidq,0644);
   c(auto_qmail,"man/man8","qmail-popup.8",auto_uido,auto_gidq,0644);
-  c(auto_qmail,"man/cat8","qmail-popup.0",auto_uido,auto_gidq,0644);
   c(auto_qmail,"man/man8","qmail-qmqpc.8",auto_uido,auto_gidq,0644);
-  c(auto_qmail,"man/cat8","qmail-qmqpc.0",auto_uido,auto_gidq,0644);
   c(auto_qmail,"man/man8","qmail-qmqpd.8",auto_uido,auto_gidq,0644);
-  c(auto_qmail,"man/cat8","qmail-qmqpd.0",auto_uido,auto_gidq,0644);
   c(auto_qmail,"man/man8","qmail-qmtpd.8",auto_uido,auto_gidq,0644);
-  c(auto_qmail,"man/cat8","qmail-qmtpd.0",auto_uido,auto_gidq,0644);
   c(auto_qmail,"man/man8","qmail-smtpd.8",auto_uido,auto_gidq,0644);
-  c(auto_qmail,"man/cat8","qmail-smtpd.0",auto_uido,auto_gidq,0644);
   c(auto_qmail,"man/man8","qmail-command.8",auto_uido,auto_gidq,0644);
-  c(auto_qmail,"man/cat8","qmail-command.0",auto_uido,auto_gidq,0644);
 }
diff -urN qmail-1.03-vanilla/hmac.h qmail-1.03-md24/hmac.h
--- qmail-1.03-vanilla/hmac.h	1970-01-01 01:00:00.000000000 +0100
+++ qmail-1.03-md24/hmac.h	2007-07-19 22:20:45.000000000 +0200
@@ -0,0 +1,4 @@
+
+extern void hmac_md5();
+extern void hmac_ripemd();
+extern void hmac_sha1();
diff -urN qmail-1.03-vanilla/hmac_md5.c qmail-1.03-md24/hmac_md5.c
--- qmail-1.03-vanilla/hmac_md5.c	1970-01-01 01:00:00.000000000 +0100
+++ qmail-1.03-md24/hmac_md5.c	2007-07-19 22:08:00.000000000 +0200
@@ -0,0 +1,56 @@
+#include <sys/types.h>
+#include <unistd.h>
+#include <string.h>
+
+#include "typesx.h"
+#include "md5.h"
+
+#define PAD 64
+#define TK  16
+
+void hmac_md5(text, key, digest)
+	u8 *text;   /* pointer to data stream */
+	u8 *key;    /* pointer to authentication key */
+	u8 *digest; /* caller digest to be filled in */
+{
+	MD5_CTX ctx;
+	u8 k_ipad[PAD+1]; /* inner padding - key XORd with ipad */
+	u8 k_opad[PAD+1]; /* outer padding - key XORd with opad */
+	u8 tk[TK];
+	size_t text_len=strlen(text);
+	size_t key_len=strlen(key);
+	int i;
+
+	if (key_len > PAD) {
+		MD5_CTX tctx;
+		MD5_Init(&tctx);
+		MD5_Update(&tctx, key, key_len);
+		MD5_Final(tk, &tctx);
+		key = tk;
+		key_len = TK;
+	}
+
+	/* start out by storing key in pads */
+	memset(k_ipad, 0, PAD);
+	memcpy(k_ipad, key, key_len);
+	memset(k_opad, 0, PAD);
+	memcpy(k_opad, key, key_len);
+
+	/* XOR key with ipad and opad values */
+	for (i=0; i<PAD; i++) {
+		k_ipad[i] ^= 0x36;
+		k_opad[i] ^= 0x5c;
+	}
+
+	/* perform inner MD5 */
+	MD5_Init(&ctx);                   /* init ctx for 1st pass */
+	MD5_Update(&ctx, k_ipad, PAD);    /* start with inner pad */
+	MD5_Update(&ctx, text, text_len); /* then text of datagram */
+	MD5_Final(digest, &ctx);          /* finish up 1st pass */
+
+	/* perform outer MD5 */
+	MD5_Init(&ctx);                   /* init ctx for 2nd pass */
+	MD5_Update(&ctx, k_opad, PAD);    /* start with outer pad */
+	MD5_Update(&ctx, digest, TK);     /* then results of 1st hash */
+	MD5_Final(digest, &ctx);          /* finish up 2nd pass */
+}
diff -urN qmail-1.03-vanilla/hmac_ripemd.c qmail-1.03-md24/hmac_ripemd.c
--- qmail-1.03-vanilla/hmac_ripemd.c	1970-01-01 01:00:00.000000000 +0100
+++ qmail-1.03-md24/hmac_ripemd.c	2007-07-19 22:08:05.000000000 +0200
@@ -0,0 +1,56 @@
+#include <sys/types.h>
+#include <unistd.h>
+#include <string.h>
+
+#include "typesx.h"
+#include "ripemd.h"
+
+#define PAD 64
+#define TK  20
+
+void hmac_ripemd(text, key, digest)
+	u8 *text;   /* pointer to data stream */
+	u8 *key;    /* pointer to authentication key */
+	u8 *digest; /* caller digest to be filled in */
+{
+	RIPEMD160_CTX ctx;
+	u8 k_ipad[PAD+1]; /* inner padding - key XORd with ipad */
+	u8 k_opad[PAD+1]; /* outer padding - key XORd with opad */
+	u8 tk[TK];
+	size_t text_len=strlen(text);
+	size_t key_len=strlen(key);
+	int i;
+
+	if (key_len > PAD) {
+		RIPEMD160_CTX tctx;
+		RIPEMD160_Init(&tctx);
+		RIPEMD160_Update(&tctx, key, key_len);
+		RIPEMD160_Final(tk, &tctx);
+		key = tk;
+		key_len = TK;
+	}
+
+	/* start out by storing key in pads */
+	memset(k_ipad, 0, PAD);
+	memcpy(k_ipad, key, key_len);
+	memset(k_opad, 0, PAD);
+	memcpy(k_opad, key, key_len);
+
+	/* XOR key with ipad and opad values */
+	for (i=0; i<PAD; i++) {
+		k_ipad[i] ^= 0x36;
+		k_opad[i] ^= 0x5c;
+	}
+
+	/* perform inner RIPEMD160 */
+	RIPEMD160_Init(&ctx);                   /* init ctx for 1st pass */
+	RIPEMD160_Update(&ctx, k_ipad, PAD);    /* start with inner pad */
+	RIPEMD160_Update(&ctx, text, text_len); /* then text of datagram */
+	RIPEMD160_Final(digest, &ctx);          /* finish up 1st pass */
+
+	/* perform outer RIPEMD160 */
+	RIPEMD160_Init(&ctx);                   /* init ctx for 2nd pass */
+	RIPEMD160_Update(&ctx, k_opad, PAD);    /* start with outer pad */
+	RIPEMD160_Update(&ctx, digest, TK);     /* then results of 1st hash */
+	RIPEMD160_Final(digest, &ctx);          /* finish up 2nd pass */
+}
diff -urN qmail-1.03-vanilla/hmac_sha1.c qmail-1.03-md24/hmac_sha1.c
--- qmail-1.03-vanilla/hmac_sha1.c	1970-01-01 01:00:00.000000000 +0100
+++ qmail-1.03-md24/hmac_sha1.c	2007-07-19 22:30:54.000000000 +0200
@@ -0,0 +1,56 @@
+#include <sys/types.h>
+#include <unistd.h>
+#include <string.h>
+
+#include "typesx.h"
+#include "sha1.h"
+
+#define PAD 64
+#define TK  20
+
+void hmac_sha1(text, key, digest)
+	u8 *text;   /* pointer to data stream */
+	u8 *key;    /* pointer to authentication key */
+	u8 *digest; /* caller digest to be filled in */
+{
+	SHA1_CTX ctx;
+	u8 k_ipad[PAD+1]; /* inner padding - key XORd with ipad */
+	u8 k_opad[PAD+1]; /* outer padding - key XORd with opad */
+	u8 tk[TK];
+	size_t text_len=strlen(text);
+	size_t key_len=strlen(key);
+	int i;
+
+	if (key_len > PAD) {
+		SHA1_CTX tctx;
+		SHA1_Init(&tctx);
+		SHA1_Update(&tctx, key, key_len);
+		SHA1_Final(tk, &tctx);
+		key = tk;
+		key_len = TK;
+	}
+
+	/* start out by storing key in pads */
+	memset(k_ipad, 0, PAD);
+	memcpy(k_ipad, key, key_len);
+	memset(k_opad, 0, PAD);
+	memcpy(k_opad, key, key_len);
+
+	/* XOR key with ipad and opad values */
+	for (i=0; i<PAD; i++) {
+		k_ipad[i] ^= 0x36;
+		k_opad[i] ^= 0x5c;
+	}
+
+	/* perform inner SHA1 */
+	SHA1_Init(&ctx);                   /* init ctx for 1st pass */
+	SHA1_Update(&ctx, k_ipad, PAD);    /* start with inner pad */
+	SHA1_Update(&ctx, text, text_len); /* then text of datagram */
+	SHA1_Final(digest, &ctx);          /* finish up 1st pass */
+
+	/* perform outer SHA1 */
+	SHA1_Init(&ctx);                   /* init ctx for 2nd pass */
+	SHA1_Update(&ctx, k_opad, PAD);    /* start with outer pad */
+	SHA1_Update(&ctx, digest, TK);     /* then results of 1st hash */
+	SHA1_Final(digest, &ctx);          /* finish up 2nd pass */
+}
diff -urN qmail-1.03-vanilla/hmac_sha1.h qmail-1.03-md24/hmac_sha1.h
--- qmail-1.03-vanilla/hmac_sha1.h	1970-01-01 01:00:00.000000000 +0100
+++ qmail-1.03-md24/hmac_sha1.h	2007-07-19 20:56:22.000000000 +0200
@@ -0,0 +1,2 @@
+
+extern void hmac_sha1();
diff -urN qmail-1.03-vanilla/hostname.c qmail-1.03-md24/hostname.c
--- qmail-1.03-vanilla/hostname.c	1998-06-15 12:53:16.000000000 +0200
+++ qmail-1.03-md24/hostname.c	2007-07-19 20:56:22.000000000 +0200
@@ -1,3 +1,5 @@
+#include <sys/types.h>
+#include <unistd.h>
 #include "substdio.h"
 #include "subfd.h"
 #include "readwrite.h"
@@ -5,7 +7,7 @@
 
 char host[256];
 
-void main()
+int main()
 {
  host[0] = 0; /* sigh */
  gethostname(host,sizeof(host));
diff -urN qmail-1.03-vanilla/idedit.c qmail-1.03-md24/idedit.c
--- qmail-1.03-vanilla/idedit.c	1998-06-15 12:53:16.000000000 +0200
+++ qmail-1.03-md24/idedit.c	2007-07-19 20:56:22.000000000 +0200
@@ -1,4 +1,5 @@
 #include <sys/types.h>
+#include <unistd.h>
 #include <pwd.h>
 #include <grp.h>
 #include "readwrite.h"
@@ -9,6 +10,7 @@
 #include "open.h"
 #include "seek.h"
 #include "fork.h"
+#include "wait.h"
 
 #define FATAL "idedit: fatal: "
 #define WARNING "idedit: warning: "
@@ -120,7 +122,7 @@
     strerr_die3x(111,FATAL,"excessively large gid for ",group);
 }
 
-void main(argc,argv)
+int main(argc,argv)
 int argc;
 char **argv;
 {
